UNIT Unit1;

{$mode objfpc}{$H+}

INTERFACE

USES
  Classes, SysUtils, Forms, Controls, Graphics, StdCtrls,
  RTL, MCE, MCS, MCB;

type

  { TForm1 }

  TForm1 = CLASS(TForm)
    Button1: TButton;
    Memo1: TMemo;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE FormCreate(Sender: TObject);
    PROCEDURE FormPaint(Sender: TObject);
  PRIVATE

  PUBLIC
    node: MCB.Item;
    data: STRING;
  END;

VAR
  Form1: TForm1;

IMPLEMENTATION

{$R *.lfm}

{ TForm1 }

PROCEDURE MarkProc(msg: ARRAY OF CHAR);
VAR
  p: LONGINT;
BEGIN
  p := pos;
  IF errcount = 0 THEN BEGIN
    Form1.memo1.lines.add('Error: ['+IntToStr(MCB.prevline)+':'+IntToStr(MCB.prevcol)+'] '+msg);
  END;
  IF (p > pos) AND (errcount < 25) THEN BEGIN
      Form1.memo1.lines.add('Error: ['+IntToStr(MCB.prevline)+':'+IntToStr(MCB.prevcol)+'] '+msg);
  END;
  INC(errcount);
  pos := p + 4;
END;

PROCEDURE TForm1.FormCreate(Sender: TObject);
BEGIN
  MCB.Mark := @MarkProc;
  Form1.canvas.font.name := 'Courier New';
  Form1.canvas.font.size := 10;
END;

PROCEDURE TForm1.FormPaint(Sender: TObject);
VAR
  i: INTEGER;
  Calc: ARRAY [0..100] OF INTEGER;

  PROCEDURE Calculate(VAR n: MCB.Item; l: INTEGER);
  BEGIN
    IF n <> NIL THEN BEGIN
      INC(l);
      INC(Calc[l]);
      if n.a <> NIL THEN Calculate(n.a,l);
      if n.b <> NIL THEN Calculate(n.b,l);
    END;
  END;

  PROCEDURE Draw(VAR n: MCB.Item; x,y,z,l: INTEGER; f: BOOLEAN);
  VAR
    xx,yy,tw,th: INTEGER;
    s    : STRING;
  BEGIN
    IF n <> NIL THEN BEGIN
      INC(l);

      s := ' ';
      CASE n.op OF
        MCS.lx_plus  : s := '+';
        MCS.lx_minus : s := '-';
        MCS.lx_times : s := '*';
        MCS.lx_rdiv  : s := '/';
        MCS.lx_mod   : s := 'MOD';
        MCS.lx_div   : s := 'DIV';
        MCS.lx_not   : s := TRIM('-'+IntToStr(n.val));
      ELSE
        IF n.typ.form = MCB.fReal THEN
          s := FloatToStr(RTL._ITR(n.val))
        ELSE IF n.typ.form = MCB.fInt THEN
          s := IntToStr(n.val)
        ELSE IF n.clas = MCB.cLit THEN
          s := n.name;
        //s := s + ' - '+n.typ.typobj.name;
      END;

      IF f THEN BEGIN
        xx := x;
        yy := y;
        x := Calc[l+50] * (width div Calc[l]);
        x := x + (width div Calc[l]) div 2;
        canvas.line(x,l*y-y+z,xx,l*yy-y-y+z);
        INC(Calc[l+50]);
      END ELSE BEGIN
        z := width div ((2 shl l) div 2) div 2;
        canvas.pen.color := $FFCCCC;
        canvas.pen.width := 2;
        if n.a <> nil  then begin canvas.line(x,l*y-y+40,x-z,l*y+40); end;
        if n.b <> nil  then begin canvas.line(x,l*y-y+40,x+z,l*y+40); end;
        canvas.brush.style := bsSolid;
        tw := canvas.textwidth(s) div 2;
        th := canvas.textheight(s);
        canvas.brush.color := $FFFFFF;
        IF n.clas = MCB.cConst THEN canvas.brush.color := $CCCCFF;
        IF n.clas = MCB.cLit   THEN canvas.brush.color := $CCFFCC;
        canvas.pen.width := 1;
        canvas.roundrect(x-tw-7,l*y-11-y+40,x+tw+7,l*y+11-y+40,20,20);
        canvas.brush.style := bsClear;
        canvas.textout(x-tw,l*y-y-th div 2+40,s);
        if n.a <> nil then Draw(n.a,x-z,y,z,l,f);
        if n.b <> nil then Draw(n.b,x+z,y,z,l,f);
      END;

      IF f THEN BEGIN
        IF n.a <> NIL THEN Draw(n.a,x,y,z,l,f);
        IF n.b <> NIL THEN Draw(n.b,x,y,z,l,f);
        canvas.brush.style := bsSolid;
        tw := canvas.textwidth(s);
        th := canvas.textheight(s);
        canvas.roundrect(x-tw-3,l*y-10-y+z,x+tw+3,l*y+10-y+z,20,20);
        canvas.brush.style := bsClear;
        canvas.textout(x-(tw div 2),l*y-y+z-th div 2,s);
      END;

    END;
  END;

BEGIN
  IF MCB.errcount = 0 THEN BEGIN
    FILLDWORD(Calc,LENGTH(Calc),0);
    Calculate(node,0);
    i := 1;
    WHILE Calc[i] <> 0 DO BEGIN INC(Calc[0]); INC(i); END;
    IF Calc[0] > 0 THEN BEGIN
      i := height div Calc[0];
      Draw(node,width div 2,i,i div 2,0,FALSE);
    END;
    (*
    canvas.pen.width   := 1;
    canvas.brush.style := bsSolid;
    canvas.pen.color   := $FFCCCC;
    canvas.brush.color := $FFFFFF;
    canvas.roundrect(10,height - 80,30,height-60,20,20);
    canvas.brush.color := $CCCCFF;
    canvas.roundrect(10,height - 55,30,height-35,20,20); *)
    //canvas.brush.color := $CCFFCC;
    //canvas.roundrect(10,height - 30,30,height-10,20,20);
  END;

  canvas.font.color  := $FF3333;
  canvas.brush.style := bsClear;
  //canvas.textout(35,height - 78,'clas = MCB.cNode');
  //canvas.textout(35,height - 53,'clas = MCB.cConst');
  //canvas.textout(35,height - 27,'clas = MCB.cLit');
  canvas.font.color  := clDefault;

  canvas.brush.style := bsSolid;
  canvas.pen.color   := $FFCCCC;
  canvas.brush.color := $FFFFFF;
  canvas.roundrect((width-canvas.textwidth(data)) div 2 -10,8,(width-canvas.textwidth(data)) div 2 + canvas.textwidth(data)+10,28,20,20);
  canvas.brush.style := bsClear;
  canvas.textout((width-canvas.textwidth(data)) div 2,10,data);

END;

PROCEDURE TForm1.Button1Click(Sender: TObject);
BEGIN
  data := '1+2+3*a/b*4+5+c+6';
  MCS.Init(@data[1],0);
  MCS.Get(sym);
  MCE.Expression(node);
  Invalidate;
  memo1.lines.add(FloatToStr( 1 - 6 DIV -3 ));
END;

END.

